package lab10_memento.ex1;

public class Game {
    private final Player player;
    private final CheckpointManager checkpointManager;

    public Game() {
        player = new Player(0, 0, 0);
        checkpointManager = new CheckpointManager();
    }

    public void printInfo() {
        System.out.println("Player position: (" + player.getX() + "," + player.getY() + ")");
        System.out.println("Player score: " + player.getScore());
        System.out.println();
    }

    public void doTurn(int dx, int dy, int score, boolean isCheckpoint) {
        player.moveTo(player.getX() + dx, player.getY() + dy);
        System.out.print("Player moves to (" + player.getX() + "," + player.getY() + ")");
        if (score != 0) {
            player.increaseScore(score);
            System.out.print(" and gains +" + score + " score");
        }
        if (isCheckpoint) {
            checkpointManager.save(player);
            System.out.print(". It's a checkpoint and their position and score are saved");
        }
        System.out.println();
        printInfo();
    }

    public void doTurn(int dx, int dy) {
        doTurn(dx, dy, 0, false);
    }

    public void doTurn(int dx, int dy, int score) {
        doTurn(dx, dy, score, false);
    }

    public void doTurn(int dx, int dy, boolean isCheckpoint) {
        doTurn(dx, dy, 0, isCheckpoint);
    }

    public void die() {
        checkpointManager.restore(player);
        System.out.println("Player died ! Returning to previous checkpoint");
        printInfo();
    }

    public static void main(String[] args) {
        Game game = new Game();

        game.printInfo();
        game.doTurn(1, 1, 100);
        game.doTurn(1, 1, true);
        game.doTurn(4, 4, 100);
        game.die();
    }
}
