package lab10_memento.ex1;

public class Player {
    private int x;
    private int y;
    private int score;

    public Player(int x, int y, int score) {
        this.x = x;
        this.y = y;
        this.score = score;
    }

    public void moveTo(int x, int y) {
        this.x = x;
        this.y = y;
    }

    public void increaseScore(int score) {
        this.score += score;
    }

    public int getX() {
        return x;
    }

    public int getY() {
        return y;
    }

    public int getScore() {
        return score;
    }

    public Checkpoint makeCheckpoint() {
        return new Checkpoint(this);
    }

    public class Checkpoint {
        private final int x;
        private final int y;
        private final int score;

        public Checkpoint(Player player) {
            x = player.getX();
            y = player.getY();
            score = player.getScore();
        }

        public int getX() {
            return x;
        }

        public int getY() {
            return y;
        }

        public int getScore() {
            return score;
        }

        public void restore(Player player) {
            player.x = this.getX();
            player.y = this.getY();
            player.score = this.getScore();
        }
    }
}
