package lab12_singleton.ex1;

import lab12_singleton.ex1.sensors.*;
import lab12_singleton.ex1.managers.*;

public class CarSensorSingletonLauncher {
    public CarSensorSingletonLauncher() {

    }

    public static void main(String[] args) {
        CarSensorSingletonLauncher launcher = new CarSensorSingletonLauncher();
        launcher.launch();
    }

    public void launch() {
        this.test(SimpleSingletonSensorsManager.getInstance());
        this.test(SynchSingletonSensorsManager.getInstance());
        this.test(EagerSingletonSensorsManager.getInstance());
        this.test(DbleCheckedSingletonSensorsManager.getInstance());
    }

    private void test(SingletonSensorManager manager) {
        manager.addSensor(new TemperatureSensor());
        manager.addSensor(new SpeedSensor());
        manager.addSensor(new RoadConditionSensor());
        manager.printState();
    }
}
