package lab13_proxy.ex1;

public class ImageProxy extends Image {
    private final Image lowResImage;
    private final Image highResImage;

    public ImageProxy(String path) {
        super(path, "high");
        lowResImage = new Image(path, "low");
        highResImage = new Image(path, "high");
    }

    public void showImage(User user) {
        System.out.println(user.getName() + " selects preview image " + path + " and wants to see its full resolution.");
        if (RegistrationService.isRegistered(user)) {
            highResImage.load();
            highResImage.showImage(user);
        } else {
            System.out.println("User " + user.getName() + " is not registered. Showing preview image in low resolution");
            lowResImage.load();
            lowResImage.showImage(user);
        }
    }
}
