package lab3_abstract_factory.ex1;

public class House {
    private String name;
    private HouseFactory houseFactory;
    private AbstractWall wall;
    private AbstractWindows windows;
    private AbstractDoor door;

    public House(String name, HouseFactory houseFactory) {
        this.name = name;
        this.houseFactory = houseFactory;
    }

    public void buildHouse() {
        wall = houseFactory.buildWall();
        windows = houseFactory.buildWindows();
        door = houseFactory.buildDoor();
        System.out.println(
            "Building a house with "
                + wall
                + ", "
                + windows
                + " and a "
                + door
        );
    }

    public void calculatePrice() {
        int total = 0;
        total += wall.getPrice();
        total += windows.getPrice();
        total += door.getPrice();

        System.out.println("Total price: " + total);
    }

    @Override
    public String toString() {
        return "House '" + name + "' (\n"
                + "  Walls: " + wall + "\n"
                + "  Windows: " + windows + "\n"
                + "  Door: " + door + "\n"
                + ")";
    }
}
