package lab3_abstract_factory.ex1.house_factories;

import lab3_abstract_factory.ex1.AbstractDoor;
import lab3_abstract_factory.ex1.AbstractWall;
import lab3_abstract_factory.ex1.AbstractWindows;
import lab3_abstract_factory.ex1.HouseFactory;
import lab3_abstract_factory.ex1.doors.LargeDoor;
import lab3_abstract_factory.ex1.walls.BricksWall;
import lab3_abstract_factory.ex1.windows.FramedWindows;

public class DutchHouseFactory extends HouseFactory {
    @Override
    public AbstractWall buildWall() {
        return new BricksWall();
    }

    @Override
    public AbstractWindows buildWindows() {
        return new FramedWindows();
    }

    @Override
    public AbstractDoor buildDoor() {
        return new LargeDoor();
    }
}
