package lab3_abstract_factory.ex1.house_factories;

import lab3_abstract_factory.ex1.AbstractDoor;
import lab3_abstract_factory.ex1.AbstractWall;
import lab3_abstract_factory.ex1.AbstractWindows;
import lab3_abstract_factory.ex1.HouseFactory;
import lab3_abstract_factory.ex1.doors.LargeDoor;
import lab3_abstract_factory.ex1.walls.GlassWall;
import lab3_abstract_factory.ex1.windows.FullHeightWindows;

public class GermanHouseFactory extends HouseFactory {
    @Override
    public AbstractWall buildWall() {
        return new GlassWall();
    }

    @Override
    public AbstractWindows buildWindows() {
        return new FullHeightWindows();
    }

    @Override
    public AbstractDoor buildDoor() {
        return new LargeDoor();
    }
}
