package lab9_responsibility_chain.ex1;

import lab9_responsibility_chain.ex1.handlers.*;

public class Main {
    public static void main(String[] args) {
        Handler spamHandler = new SpamHandler();
        Handler fanHandler = new FanHandler();
        Handler complaintHandler = new ComplaintHandler();
        Handler newLocHandler = new NewLocHandler();

        spamHandler.setSuccessor(fanHandler);
        fanHandler.setSuccessor(complaintHandler);
        complaintHandler.setSuccessor(newLocHandler);

        Email email1 = new Email("You WON the LoTtErY !!!!!", EmailType.SPAM);
        Email email2 = new Email("Your company is awesome !", EmailType.FAN);
        Email email3 = new Email("My children are addicted :(", EmailType.COMPLAINT);
        Email email4 = new Email("Please come to Sion :)", EmailType.NEW_LOC);

        spamHandler.handleEmail(email1);
        spamHandler.handleEmail(email2);
        spamHandler.handleEmail(email3);
        spamHandler.handleEmail(email4);
    }
}
