package learn.simple_abstract_factory;

public class Client {
    private AbstractFactory abstractFactory;

    private AbstractProductA productA;
    private AbstractProductB productB;

    public Client(AbstractFactory abstractFactory) {
        this.abstractFactory = abstractFactory;
    }

    public void setup() {
        productA = abstractFactory.createProductA();
        productB = abstractFactory.createProductB();
    }

    public void setAbstractFactory(AbstractFactory abstractFactory) {
        this.abstractFactory = abstractFactory;
    }

    @Override
    public String toString() {
        return "Client{" +
                "productA=" + productA +
                ", productB=" + productB +
                '}';
    }
}
