package learn.simple_flyweight;

import java.util.Random;

public class Main {
    private static final Random rand = new Random();

    public static void main(String[] args) {
        int rounds = 100;

        debugMemory();
        testFlyweight(rounds);
        debugMemory();
        testUnsharedFlyweight(rounds);
        debugMemory();
    }

    private static void debugMemory() {
        long totalMemory = Runtime.getRuntime().totalMemory();
        long freeMemory = Runtime.getRuntime().freeMemory();
        long usedMemory = totalMemory - freeMemory;
        System.out.printf("Memory: %d%n", usedMemory);
    }

    private static void testFlyweight(int rounds) {
        FlyweightFactory factory = new FlyweightFactory();

        for (int i = 0; i < rounds; i++) {
            Flyweight flyweight = factory.getFlyweight(rand.nextInt(10));
            flyweight.operation(i);
        }
    }

    private static void testUnsharedFlyweight(int rounds) {
        for (int i = 0; i < rounds; i++) {
            Flyweight flyweight = new UnsharedConcreteFlyweight(rand.nextInt(10));
            flyweight.operation(i);
        }
    }
}
