package learn.simple_memento;

import java.util.Stack;

public class CareTaker {
    private final Stack<Originator.Memento> snapshots = new Stack<>();

    public void save(Originator.Memento memento) {
        snapshots.push(memento);
    }

    public void revert(Originator originator) {
        if (!snapshots.isEmpty()) {
            originator.setMemento(snapshots.pop());
        } else {
            System.out.println("No saved memento to revert");
        }
    }
}
